.486
.model  flat, stdcall  
option  casemap :none 

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\gdi32.inc
include \masm32\include\ole32.inc
include \masm32\include\oleaut32.inc
include \masm32\include\winmm.inc
   
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\ole32.lib
includelib \masm32\lib\oleaut32.lib
includelib \masm32\lib\winmm.lib
 
include ufmod.inc  
includelib ufmod.lib  
   
include \masm32\macros\macros.asm

WinMain           PROTO :DWORD, :DWORD, :DWORD, :DWORD
WndProc           PROTO :DWORD, :DWORD, :DWORD, :DWORD
ToggleFullScreen  PROTO :DWORD
Window_changed    PROTO :DWORD
.const

PictureW      equ 600
PictureH      equ 400

.data 

ClassName       db "Win32asm_class",0
DisplayName     db ".:. Blank Window .:.",0
MyRect      RECT <0,0,PictureW,PictureH>

black           dd 0000000h
bWindowed      dd TRUE
dwWindow_Width  dd 600 ; our values
dwWindow_Height dd 400

bProg_active   dd TRUE

bMinimized    dd FALSE
bMaximized    dd FALSE

.data? 
Heap         dd ?
hInstance       dd ?
hmainDC         dd ?                                        
hmainbmp        dd ? 
WndProc_ptr     dd ?
WndProcF_ptr    dd ?
WindowRect   RECT <?>
rcPrimary    RECT <?>
dwScreenWidth      dd ?    ; window changes
dwScreenHeight     dd ?

ScreenWidth        dd ?    ; Auto init actual values
ScreenHeight       dd ?
ScreenBits         dd ?
ScreenRefreshRate  dd ?

Xwindow dd ?
Ywindow dd ?
Xwindowdiv2 dd ?
Ywindowdiv2 dd ?

hArrPlan dd ?
rect RECT <?, ?, ?, ?>

.code 

start:
    invoke GetSystemMetrics, SM_CXSCREEN
    mov Xwindow, eax
    shr eax, 1
    mov Xwindowdiv2, eax
    invoke GetSystemMetrics, SM_CYSCREEN
    mov Ywindow, eax
    shr eax, 1
    mov Ywindowdiv2, eax

    invoke  CoInitialize,NULL
    invoke  GetModuleHandle, NULL
    mov   hInstance,eax
    invoke   GetProcessHeap
    mov   Heap,eax
    invoke   WinMain,hInstance,NULL,NULL,SW_SHOWDEFAULT
    invoke  ExitProcess,eax
WinMain   PROC hInst :DWORD,hPrevInst :DWORD,CmdLine :DWORD,CmdShow :DWORD

LOCAL   wc   :WNDCLASSEX
LOCAL   msg  :MSG
LOCAL   hwnd :HWND

        mov     wc.cbSize,sizeof WNDCLASSEX
        mov     wc.style,CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
        mov     wc.lpfnWndProc,offset WndProc
        mov     wc.cbClsExtra,NULL
   mov      wc.cbSize,sizeof WNDCLASSEX
   mov      wc.style,CS_HREDRAW or CS_VREDRAW or CS_OWNDC
   mov      eax,offset WndProcfullscreen
   mov      WndProcF_ptr,eax
   mov      eax,offset WndProc
   mov      WndProc_ptr,eax
   mov      wc.lpfnWndProc,eax
   mov      wc.cbClsExtra,NULL
   mov      wc.cbWndExtra,NULL
   mov      eax,hInst

        mov     wc.cbWndExtra,NULL      
        push    hInst

        pop     wc.hInstance

        mov     wc.hbrBackground,COLOR_BTNFACE+4
          invoke GetStockObject, BLACK_BRUSH
      mov hArrPlan, eax
        mov     wc.lpszMenuName,NULL
        mov     wc.lpszClassName,offset ClassName             
        mov     wc.hIcon,NULL
        invoke  LoadCursor,NULL,IDC_ARROW				
        mov     wc.hCursor,eax      
        mov     wc.hIconSm,NULL
          invoke CreateWindowEx, NULL, OFFSET ClassName, OFFSET DisplayName, WS_POPUP, 0, 0, Xwindow, Ywindow, NULL, NULL, hInst, NULL
      mov hwnd, eax
      invoke ShowWindow, hwnd, SW_SHOWDEFAULT
        invoke  RegisterClassEx, ADDR wc


        invoke  GetSystemMetrics,SM_CXSCREEN
        shr     eax,1
        sub     eax,PictureW/2
        push    eax

        invoke  GetSystemMetrics,SM_CYSCREEN
        shr     eax,1
        sub     eax,PictureH/2
        pop     ebx

        invoke  CreateWindowEx,WS_EX_LEFT,ADDR ClassName,ADDR DisplayName,
                WS_OVERLAPPEDWINDOW,ebx,eax,PictureW,PictureH,NULL,NULL,hInst,NULL
        mov     hwnd,eax
        push eax
   mov      hwnd,eax

invoke	uFMOD_PlaySong,200,hInstance,XM_RESOURCE
   invoke   Window_changed,eax

   .if (!bWindowed)
       invoke   GetWindowRect,hwnd,addr WindowRect
       invoke   SetWindowLong,hwnd,GWL_EXSTYLE,WS_EX_TOPMOST
       invoke   SetWindowLong,hwnd,GWL_STYLE,WS_POPUP
       invoke   SetWindowLong,hwnd,GWL_WNDPROC,WndProcF_ptr
   .endif

   invoke   UpdateWindow,hwnd
   invoke   ShowWindow,hwnd,SW_SHOWNORMAL
        mov edi, hwnd
        invoke  ShowWindow,edi,SW_SHOWNORMAL
        invoke  UpdateWindow,edi



  invoke   RtlZeroMemory,addr msg,sizeof msg

   .while TRUE
      invoke PeekMessage,addr msg,NULL,0,0,PM_REMOVE
      .if eax != 0
          .if msg.message == WM_QUIT
              invoke PostQuitMessage,msg.wParam
              .break
          .else
              invoke TranslateMessage,addr msg
              invoke DispatchMessage,addr msg
          .endif 
      .else
       
      .endif
   .endw

	invoke	uFMOD_PlaySong,0,0,0

   invoke   CoUninitialize
   invoke   UnregisterClass,addr ClassName,wc.hInstance

   mov      eax,msg.wParam
   ret
WinMain         ENDP

WndProc  PROC   uses edx ecx ebx esi edi  hWnd :HWND,uMsg :DWORD,wParam :DWORD,lParam :DWORD


	LOCAL hdc:HDC
	LOCAL ps:PAINTSTRUCT

mov eax, uMsg  



 .if eax == WM_SIZE   ; check if window size has changed
       .if wParam == SIZE_MINIMIZED
           mov      bProg_active,FALSE
           mov      bMinimized,TRUE
           mov      bMaximized,FALSE
       .elseif wParam == SIZE_MAXIMIZED
           invoke   Window_changed,hWnd
           mov      bMinimized,FALSE
           mov      bMaximized,TRUE
       .elseif wParam == SIZE_RESTORED
           .if (bMaximized)
               invoke   Window_changed,hWnd
               mov      bMaximized,FALSE
           .elseif (bMinimized)
               mov      bProg_active,TRUE
               mov      bMinimized,FALSE
           .endif
       .endif
       return   0



.ENDIF
     .IF eax == WM_PAINT 

invoke BeginPaint,hWnd, ADDR ps
mov    hdc,eax


invoke BitBlt, hdc, 0,0, PictureW,PictureH, hmainDC, 0, 0, SRCCOPY

invoke EndPaint,hWnd, ADDR ps

; -------------------------------------------------------------------------

; -------------------------------------------------------------------------
    .ELSEIF     eax == WM_TIMER

invoke FillRect, hmainDC, addr MyRect,black
invoke RedrawWindow, hWnd, addr MyRect, 0, RDW_INVALIDATE	

; -------------------------------------------------------------------------
   .ELSEIF eax == WM_CREATE

invoke CreateSolidBrush,black
mov black,eax


  invoke GetDC, hWnd
  mov hdc, eax

  mov esi,PictureW
  mov edi,PictureH


  invoke CreateCompatibleDC, hdc
  mov dword ptr [hmainDC],eax

  invoke CreateCompatibleBitmap, hdc, esi, edi
  mov dword ptr [hmainbmp],eax

  invoke SelectObject, [hmainDC], eax
  
  invoke ReleaseDC,hWnd, hdc

; ====================================
; ====================================  

    .ELSEIF eax == WM_CLOSE
destroy:
invoke PostQuitMessage,NULL
invoke DeleteDC, [hmainDC]
  invoke   DeleteDC,hdc
invoke DeleteObject, [hmainbmp]
invoke DeleteObject, black

.ENDIF


   .IF  eax == WM_KEYDOWN

cmp wParam, VK_ESCAPE
je destroy

    .ELSEIF  wParam == VK_F1
   invoke   ToggleFullScreen,hWnd
 
  invoke   Window_changed,hWnd


   .else
  invoke   DefWindowProc,hWnd,uMsg,wParam,lParam
     ret
   .endif
  xor eax,eax 
ret

WndProc  ENDP
WndProcfullscreen proc uses ebx hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

      LOCAL hDC:HANDLE
      LOCAL hMemDC:HANDLE
      LOCAL hBmp:HANDLE
      LOCAL ps:PAINTSTRUCT

      .IF uMsg == WM_CREATE
  mov rect.left, 0
        mov rect.top, 0
        push Xwindow
        pop rect.right
        push Ywindow
        pop rect.bottom
  invoke GlobalAlloc, GMEM_MOVEABLE or GMEM_ZEROINIT,  hInstance
       mov hInstance, eax
        invoke GlobalLock, hInstance
        mov hInstance, eax
        invoke ShowCursor, FALSE
      .ELSEIF uMsg == WM_DESTROY
        invoke ShowCursor, TRUE
 
        invoke PostQuitMessage, NULL
      .ELSEIF uMsg == WM_KEYDOWN
        .IF wParam == VK_ESCAPE
          invoke SendMessage, hWnd, WM_DESTROY, NULL, NULL

        .ELSEIF wParam == VK_F1
        invoke   ToggleFullScreen,hWnd
        invoke   Window_changed,hWnd
        .ENDIF
      
      .ELSEIF uMsg == WM_PAINT
        invoke BeginPaint, hWnd, ADDR ps
        mov hDC, eax
        invoke CreateCompatibleDC, hDC
        mov hMemDC, eax
        invoke CreateCompatibleBitmap, hDC, Xwindow, Ywindow
        mov hBmp, eax
        invoke SelectObject, hMemDC, hBmp
        invoke FillRect, hMemDC, OFFSET MyRect , hArrPlan
        xor ecx, ecx
  invoke BitBlt, hDC, 0, 0, Xwindow,Ywindow, hMemDC, 0, 0, SRCCOPY
        invoke DeleteObject, hBmp
        invoke DeleteDC, hMemDC
        invoke EndPaint, hWnd, ADDR ps
      .ELSE
        invoke DefWindowProc, hWnd, uMsg, wParam, lParam
        ret
      .ENDIF
      xor eax, eax
      ret
WndProcfullscreen endp


ToggleFullScreen proc hwnd:DWORD
   .if (!bWindowed)
       invoke   SetWindowLong,hwnd,GWL_EXSTYLE,WS_EX_CLIENTEDGE
       invoke   SetWindowLong,hwnd,GWL_STYLE,WS_OVERLAPPEDWINDOW
       invoke   SetWindowLong,hwnd,GWL_WNDPROC,WndProc_ptr
       mov      eax,WindowRect.right
       sub      eax,WindowRect.left
       mov      ecx,WindowRect.bottom
       sub      ecx,WindowRect.top
       invoke   SetWindowPos,hwnd,HWND_NOTOPMOST,WindowRect.left,WindowRect.top,eax,ecx,SWP_SHOWWINDOW
       mov      bWindowed,TRUE
       invoke   Window_changed,hwnd
   .else
       invoke   GetWindowRect,hwnd,addr WindowRect
       invoke   SetWindowLong,hwnd,GWL_EXSTYLE,WS_EX_TOPMOST
       invoke   SetWindowLong,hwnd,GWL_STYLE,WS_POPUP
       invoke   SetWindowLong,hwnd,GWL_WNDPROC,WndProcF_ptr
       mov      bWindowed,FALSE
   .endif
   ret
ToggleFullScreen endp
Window_changed proc hwnd:DWORD
   invoke  GetClientRect,hwnd,addr rcPrimary
   invoke  ClientToScreen,hwnd,addr rcPrimary.left
   invoke  ClientToScreen,hwnd,addr rcPrimary.right

   m2m     dwScreenWidth,rcPrimary.right
   mov     eax,rcPrimary.left
   sub     dwScreenWidth,eax
   m2m     dwScreenHeight,rcPrimary.bottom
   mov     eax,rcPrimary.top
   sub     dwScreenHeight,eax

 
   ret
Window_changed endp

END start